# Drupal Log Middleware

## Contents of this file

- [Introduction](#introduction)
- [Requirements](#requirements)
- [Installation](#installation)
- [Configuration](#configuration)
- [Maintainers](#maintainers)

## Introduction

This module provides a customized `LoggerChannel` implementation with
support for middleware. The logger channel and the logger channel factory
extend the drupal core equivalents and just add support for middleware. Nothing
else is altered in the logger channel implementation.

The module just provides support for middleware and does not provide
middleware itself.

Without modules providing middleware the logger functions exactly
the same as the drupal core one.

### Adding Middleware

Each service tagged with `log_middleware` will automatically be attached
to the logger channel and is applied before processing the log message.

A middleware can alter the log level, message and context.
Additionally a middleware can discard a message entirely.

The service tag supports the following arguments:

- `priority`: a numeric value indicating the order of which the middleware
  is run. The higher the number the earlier the middleware is applied.
  Negative values are allowed.
- `channels`: an array with the logger channel names this middleware should
  be applied to. If empty, the middleware is applied to all channels.

All arguments are optional.

Example middleware implementations can be found in the
`./tests/modules/log_test_middleware` module.

## Requirements

The core module requires Drupal 10.3 or 11.

## Installation

Install as you would normally install a contributed Drupal module. For further
information, see
[Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).

## Configuration

The module does not support configuration.

## Maintainers

Current maintainers:

- Christoph Niedermoser ([@nimoatwoodway](https://www.drupal.org/u/nimoatwoodway))
- Christian Foidl ([@chfoidl](https://www.drupal.org/u/chfoidl))
