<?php

declare(strict_types=1);

namespace Drupal\log_test_middleware;

use Drupal\log_middleware\Middleware\LogMiddlewareInterface;
use Drupal\log_middleware\Middleware\LogMiddlewareResult;
use Symfony\Component\DependencyInjection\Attribute\AutoconfigureTag;

/**
 * Test middleware.
 */
#[AutoconfigureTag('log_middleware', [
  'channels' => ['specific'],
  'priority' => 10,
])]
class LogChannelSpecificTestMiddleware implements LogMiddlewareInterface {

  /**
   * {@inheritdoc}
   */
  public function alterLog(string $channel, mixed &$level, string|\Stringable &$message, array &$context): LogMiddlewareResult {
    $level = 'warning';
    $message = 'specific middleware altered';

    return LogMiddlewareResult::Next;
  }

}
