<?php

declare(strict_types=1);

namespace Drupal\log_test_middleware;

use Drupal\log_middleware\Middleware\LogMiddlewareInterface;
use Drupal\log_middleware\Middleware\LogMiddlewareResult;
use Symfony\Component\DependencyInjection\Attribute\AutoconfigureTag;

/**
 * Test middleware.
 */
#[AutoconfigureTag('log_middleware')]
class LogTestMiddleware implements LogMiddlewareInterface {

  /**
   * {@inheritdoc}
   */
  public function alterLog(string $channel, mixed &$level, string|\Stringable &$message, array &$context): LogMiddlewareResult {
    if ($channel === "alter_level") {
      $level = 'error';
    }

    if ($channel === "alter_message") {
      $message = "message from middleware";
    }

    if ($channel === "discard") {
      return LogMiddlewareResult::DiscardMessage;
    }

    return LogMiddlewareResult::Next;
  }

}
